<template>
    <div class="paginator-container">
        <a v-if="$props.page >= 1" @click="navigated($props.page - 1)" class="pagelink navlink">&lt;</a>
        <span class="smallnav">
            {{smallnav()}}
        </span>
        <a
                v-for="pagenr in totalNrPages()"
                v-bind:key="pagenr"
                @click="navigated(pagenr)"
                v-bind:class="{pagelink: true, desktoplink: true, selected: pagenr === page}"
        >
            {{pagenr}}
        </a>
        <a v-if="$props.page < totalNrPages()" @click="navigated($props.page + 1)" class="pagelink navlink">&gt;</a>
    </div>
</template>
<script lang="ts">
  import { Component, Vue } from 'vue-property-decorator';
  import i18n from './i18n';

  @Component({
      i18n,
      props: {
        size: {
          type: Number,
          default: 1
        },
        page: {
          type: Number,
          required: true
        },
        rows: {
          type: Array,
          required: true
        }
      },
      components: {}
    }
  )
  class Paginator extends Vue {
    navigated(page: number): void {
      this.$emit('update:page', page);
    }

    totalNrPages(): number {
      return this.$props.rows ? Math.ceil(this.$props.rows.length / this.$props.size) : 1;
    }

    smallnav(): string {
      const start = this.$props.size * (this.$props.page - 1) + 1;
      const total = this.$props.rows.length;
      const end = Math.min(total, this.$props.size * this.$props.page);
      return this.$t('paginator', { start, end, total }).toString();
    }
  }

  export default Paginator;
</script>
<style scoped>
    .paginator-container {
        display: flex;
        align-items: center;
    }

    .pagelink {
        cursor: pointer;
        margin-left: 4px;
        margin-right: 4px;
    }

    .selected {
        text-decoration: none;
        cursor: default;
        font-size: 1.4em;
        color: black !important;
    }

    .navlink {
        font-size: 1.2em;
    }

    .smallnav {
        background-color: var(--table-odd-bg-color);
        padding: 2px;
        border: 1px solid grey;
        border-radius: 2px;
        display: none;
    }

    @media only screen and (max-width: 600px) {
        .desktoplink {
            display: none !important;
        }

        .navlink {
            font-size: 3em;
            margin-left: 10px;
            margin-right: 10px;
            color: grey !important;
        }

        .smallnav {
            display: inline-block;
            flex: 1000 1px;
        }

        .paginator-container {
            width: 100%;
        }

        .paginator-container A {
            text-decoration: none !important;
        }
    }
</style>
